



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>getResource()和getResourceAsStream以及路径问题【转】【补】</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">getResource()和getResourceAsStream以及路径问题【转】【补】</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-24 23:20:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>一&nbsp;getResource</h1>
<p>用JAVA获取文件，听似简单，但对于很多像我这样的新人来说，还是掌握颇浅，用起来感觉颇深，大常最经常用的，就是用JAVA的File类，如要取得c:/test.txt文件，就会这样用File file = new File("c:/test.txt");这样用有什么问题，相信大家都知道，就是路径硬编码，对于JAVA精神来说，应用应该一次成型，到处可用，并且从现实应用来讲，最终生成的应用也会部署到Windows外的操作系统中，对于linux来说，在应用中用了c:/这样的字样，就是失败，所以，我们应该尽量避免使用硬编码，即直接使用绝对路径。</p>
<p>　　在Servlet应用中，有一个getRealPath(String str)的方法，这个方法尽管也可以动态地获得文件的路径，不必直接手写绝对路径，但这也是一个不被建议使用的方法，那么，我们有什么方法可以更好地获得文件呢?</p>
<p>那就是Class.getResource()与Class.getResourceAsStream()方法，但很多人还是不太懂它的用法，因为很多人（比如不久前的我）都不知道应该传怎么样的参数给它，当然，有些人己经用得如火纯青，这些人是不需要照顾的，在此仅给不会或者还不是很熟的人解释一点点。</p>
<p>比如我们有以下目录</p>
<p>|--project</p>
<p>|--src</p>
<p>|--javaapplication</p>
<p>|--Test.java</p>
<p>|--file1.txt</p>
<p>|--file2.txt</p>
<p>|--build</p>
<p>|--javaapplication</p>
<p>|--Test.class</p>
<p>|--file3.txt</p>
<p>|--file4.txt</p>
<p>在上面的目录中，有一个src目录，这是JAVA源文件的目录，有一个build目录，这是JAVA编译后文件(.class文件等）的存放目录</p>
<p>那么，我们在Test类中应该如何分别获得</p>
<p>file1.txt&nbsp;&nbsp;file2.txt&nbsp;&nbsp;file3.txt&nbsp;&nbsp;file4.txt这四个文件呢？</p>
<p>首先讲file3.txt与file4.txt</p>
<p>file3.txt:</p>
<div>
<pre class="prettyprint linenums">//方法一：<br />
File file3 = new File(Test.class.getResource("file3.txt").getFile());

//方法二：<br />
File file3 = new File(Test.class.getResource("/javaapplication/file3.txt").getFile());

//方法三：<br />
File file3 = new File(Test.class.getClassLoader().getResource("javaapplication/file3.txt").getFile());</pre>
</div>
<p>file4.txt:</p>
<div>
<pre class="prettyprint linenums">//方法一：<br />
File file4 = new File(Test.class.getResource("/file4.txt").getFile());

//方法二：<br />
File file4 = new File(Test.class.getClassLoader().getResource("file4.txt").getFile());</pre>
</div>
<p>很好，我们可以有多种方法选择，但是file1与file2文件呢？如何获得？</p>
<p>答案是，你只能写上它们的绝对路径，不能像file3与file4一样用class.getResource()这种方法获得，它们的获取方法如下</p>
<p>假如整个project目录放在c:/下，那么file1与file2的获取方法分别为</p>
<p>file1.txt</p>
<div>
<pre class="prettyprint linenums">//方法一：<br />
File file1 = new File("c:/project/src/javaapplication/file1.txt");

//方法二：。。。没有</pre>
</div>
<p>file2.txt</p>
<div>
<pre class="prettyprint linenums">//方法一：<br />
File file2 = new File("c:/project/src/file2.txt");

//方法二：。。。也没有</pre>
</div>
<p>总结一下:</p>
<p>　　就是你想获得文件，你得从最终生成的.class文件为着手点，不要以.java文件的路径为出发点，因为真正使用的就是.class，不会拿个.java文件就使用，因为java是编译型语言嘛。</p>
<p>　　至于getResouce()方法的参数，你以class为出发点，再结合相对路径的概念，就可以准确地定位资源文件了，至于它的根目录嘛，你用不同的IDE build出来是不同的位置下的，不过都是以顶层package作为根目录，比如在Web应用中，有一个WEB-INF的目录，WEB-INF目录里面除了web.xml文件外，还有一个classes目录，没错了，它就是你这个WEB应用的package的顶层目录，也是所有.class的根目录&ldquo;/&rdquo;，<strong>假如classes目录下面有一个file.txt文件，它的相对路径就是"/file.txt"，如果相对路径不是以"/"开头，那么它就是相对于.class的路径</strong>。</p>
<p>　　<strong>还有一个getResourceAsStream()方法，它相当于你用getResource()取得File文件后，再new InputStream(file)一样的结果.</p>
<p></strong></p>
<h1>二&nbsp;getResourceAsStream</h1>
<p>java路径问题（一）&mdash;&mdash;getClass().getResourceAsStream()</p>
<p>转自---&gt;<a href="http://ouyangfei0426.iteye.com/blog/1020232" rel="external nofollow noreferrer">http://ouyangfei0426.iteye.com/blog/1020232</a><br />src(源文件夹)<br />┃<br />┣━11.properties<br />┃<br />┗━myspider（myspider包）<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ┃<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ┣━22.properties<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ┗━Test.java</p>
<div>
<pre class="prettyprint linenums">import java.io.UnsupportedEncodingException;  

/**<br />
 *<br />
 * @author mark<br />
 */<br />
public class Test {<br />
    public static void main(String[] args) throws UnsupportedEncodingException{<br />
        Test t=new Test();<br />
        //文件名前不加&ldquo;/&rdquo;，则表示从当前类所在的包下查找该资源。如下则表示的是从包myspider下查找22.properties文件资源。<br />
        System.out.println("1："+t.getClass().getResourceAsStream("22.properties"));//输出java.io.BufferedInputStream@61de33  

        //文件名前加了&ldquo;/&rdquo;，则表示从类路径下也就是从classes文件夹下查找资源，如下表示从classes文件夹下查找22.properties文件资源。<br />
        System.out.println("2："+t.getClass().getResourceAsStream("/22.properties"));//输出null  

        //文件名前加了&ldquo;/&rdquo;，则表示从类路径下也就是从classes文件夹下查找资源，如下表示从classes文件夹下查找11.properties文件资源。<br />
        System.out.println("3："+t.getClass().getResourceAsStream("/11.properties"));//输出java.io.BufferedInputStream@14318bb<br />
        System.out.println();  

        //当前包路径4：file:/E:/myobject/myspider/build/classes/myspider/<br />
        System.out.println("4："+t.getClass().getResource(""));  

        //输出当前类路径5：file:/E:/myobject/myspider/build/classes/<br />
        System.out.println("5："+t.getClass().getResource("/"));  

    }<br />
}</pre>
</div>
<h1>三 Properties</h1>
<p>properties读取三种方式 及 getResourceAsStream("xxx")路径问题</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/756542/201510/756542-20151015140336976-309989595.png" /></p>
<div>
<pre class="prettyprint linenums">package a.b;

import java.io.FileInputStream;<br />
import java.io.IOException;<br />
import java.io.InputStream;<br />
import java.util.Properties;

import a.b.c.Third;

public class Second {<br />
    public static void main(String[] args) {<br />
//        getClassLoader();<br />
//        getResourceAsStream();<br />
        fileInputStream();<br />
    }

    public static void getClassLoader(){<br />
        Properties prop = new Properties();<br />
        InputStream inStream = null;<br />
        try {<br />
//             OK,"/"代表了ClassPath根目录,path不能用"/"开头,最终是由ClassLoader获取资源<br />
//                    总之Third.class.getClassLoader()一般都是从classes下直接开始的. 记住getClassLoader(不要从/开始就好了)<br />
            inStream = Third.class.getClassLoader().getResourceAsStream("config.properties");<br />
            prop.load(inStream);<br />
            System.out.println(prop.getProperty("username"));<br />
            System.out.println(prop.getProperty("password"));<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    public static void getResourceAsStream() {<br />
        Properties prop = new Properties();<br />
        InputStream inStream = null;<br />
        try {<br />
//            都是从当前类的目录下开始获取<br />
//             OK<br />
//            inStream = Second.class.getResourceAsStream("config.properties"); 

//             OK,没有"/"就代表从当前目录开始<br />
            inStream = Second.class.getResourceAsStream("c/config.properties"); 

//             OK,"/"代表了ClassPath根目录,path可以用"/"开头,最终是由ClassLoader获取资源<br />
//            inStream = Second.class.getResourceAsStream("/a/b/c/config.properties");<br />
            prop.load(inStream);<br />
            System.out.println(prop.getProperty("username"));<br />
            System.out.println(prop.getProperty("password"));<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

    public static void fileInputStream(){<br />
        Properties prop = new Properties();<br />
        InputStream inStream = null;<br />
        try {<br />
            //只能用绝对路径,不能用相对...晕<br />
            inStream = new FileInputStream("D://config.properties");<br />
            prop.load(inStream);<br />
            System.out.println(prop.getProperty("username"));<br />
            System.out.println(prop.getProperty("password"));<br />
        } catch (IOException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }

}</pre>
</div>
<p>总结 :getResourceAsStream读取的文件路径只局限在工程的源文件夹中，包括在工程src根目录下，以及类包里面任何位置，但是如果配置文件路径是在除了源文件夹之外的其他文件夹中时，该方法是用不了的。</p>
<h4>其它</h4>
<div>
<pre class="prettyprint linenums">System.getProperties().getProperty("java.io.tmpdir"); //java.io.tmpdir为系统自带临时目录C:\Users\King\AppData\Local\Temp\<br />
this.getClass().getClassLoader().getResource("/").getPath().split("WEB-INF")[0]+"template/";//  可以得到WEB-INF路径</pre>
</div>
<blockquote><p>引用自: 心碎逍遥的博客&nbsp;<a href="http://blog.sina.com.cn/s/blog_4b5bc0110100g22w.html" rel="external nofollow noreferrer">http://blog.sina.com.cn/s/blog_4b5bc0110100g22w.html</a>&nbsp;讲得非常清楚,很值得一看.</p>
<p>部分参考自: &nbsp;<a href="http://www.cnblogs.com/linjiqin/archive/2011/02/14/1954647.html" rel="external nofollow noreferrer">http://www.cnblogs.com/linjiqin/archive/2011/02/14/1954647.html</a></p>
<p>其它未引用,但讲得好的网址:&nbsp;<a href="http://blog.csdn.net/wjl_mgqs/article/details/7554741" rel="external nofollow noreferrer">http://blog.csdn.net/wjl_mgqs/article/details/7554741</a></p></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1yye2q.html">disconf安装部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwx42k9.html">NuGet在创建pack时提示&rdquo;The replacement token &amp;&num;39&semi;author&amp;&num;39&semi; has no value&OpenCurlyDoubleQuote;问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9613748.html">诠释Linux中『一切都是文件』概念和相应的文件类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxj1o8.html">ARGB32 to YUV12 利用 SDL1&period;2 SDL&lowbar;ttf 在视频表面输出文本</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdngr48.html">docker学习&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xkpdm8.html">本地yum源</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m4p1kq.html">C语言struct类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvx7n8.html">c&plus;&plus; stl algorithm&colon; std&colon;&colon;fill&comma; std&colon;&colon;fill&lowbar;n</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymyyx9.html">EF 下的code fist 模式编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljk2569.html">解决shiro和quartz2 版本冲突问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo31m3q.html">ajax数据请求2（json格式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10j02q.html">git打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxl369.html">mysql数据库插入数据获取自增主键的三种方式（jdbc PreparedStatement方式、mybatis useGeneratedKeys方式、mybatis selectKey方式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxzz59.html">UVA1349：Optimal Bus Route Design</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzonlg8.html">分布式缓存技术redis学习系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgv05d8.html">2018-2019-2 20165314『网络对抗技术』Exp5：MSF基础应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyyyln9.html">07arguments对象&period;html</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyygx2dq.html">Python sys&period;argv&lbrack;&rsqb;用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkj0m9.html">服务器&amp;amp&semi;linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r77y08.html">&lbrack;洛谷 P2508&rsqb; 圆上的整点</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9r542ndq.html">网络流相关知识点以及题目&sol;&sol;POJ1273 POJ 3436 POJ2112 POJ 1149</a>
			</li>
						<li><a href="https://www.batexi.com/a/960mrg49.html">【cf789C】Functions again（最大子序列和）</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gp22vq.html">「JLOI2015」战争调度 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy2zm2q.html">「SDOI2014」向量集 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rdz7n9.html">使用matplotlib&period;pylab绘制分段函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmyor9.html">luogu4159 迷路 &lpar;矩阵加速&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e40nrm9.html">bzoj3959&lpar;LCT&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyvdl19.html">&lbrack;WC2014&rsqb;紫荆花之恋&lpar;动态点分治&plus;替罪羊思想&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2d376q.html">numpy ndarray求其最值的索引</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wj5mnq.html">Python中字符串、列表、元组、字典、集合常用方法总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
